#ifndef __TYPES_H__
#define __TYPES_H__
#include <limits.h>

#define inf INT_MAX-250

struct _Node;

struct _Edge
{
    int weight;
    struct _Node *to;
    struct _Edge *next;
};

struct _Node
{
    int SKP; //Shortest known path
    struct _Edge *edges;
    struct _Edge *last;
    int index; //Index in Heap
    int graph_index;
};

struct __HeapPtr
{
    struct _Node **head;
    int d;
    int n; 
    int nodes_n;
};

typedef struct _Node Node;
typedef struct _Edge Edge;
typedef struct __HeapPtr HeapPtr;

#endif
